\name{PopGplot}

\docType{methods}
\alias{PopGplot}


\title{Smoothed line-plot for multiple populations}


\description{
This function plots values with smoothed lines using spline interpolation.
}

\usage{

PopGplot(values,colors=FALSE,span=0.1)

}

\arguments{
\item{values}{the statistical values (matrix) columns=populations}
\item{colors}{the colors for each population (character vector)}
\item{span}{the degree of smoothing} 
}  

\examples{

# GENOME.class <- readSNP("Arabidopsis",CHR=1)
# GENOME.class.slide <- sliding.window.transform(test,1000,1000)
# GENOME.class.slide <- diversity.stats(GENOME.class.slide)
# values <- GENOME.class.slide@nuc.divesity.within
# PopGplot(values)

}



\keyword{methods}
